C
C
C
      subroutine steptrigrob(y,x,n,res,res1,ress,pp,scl,alpha,kmax,cnt
     $     ,fcnt,verb)
      integer n,kmax
      double precision y(n),x(n,3),res(n),res1(n),ress(n),pp(n,2)
      double precision scl,alpha,cnt,fcnt
      logical verb

      double precision pi,sd10,sd20,ss0,ss1,pval,ss
      double precision theta(3),th,beta1,beta2,sx1,sx2
      integer i,j,jb,icount
      double precision rhoh,psih,psih1,prgamma
C
      pi=4d0*datan(1d0)
      ss0=0d0
      sd10=0d0
      sd20=0d0
      do 10 i=1,n
         res(i)=y(i)
         ss0=ss0+rhoh(res(i)/scl,cnt)
         sd10=sd10+psih(res(i)/scl,cnt)**2
         sd20=sd20+psih1(res(i)/scl,cnt)
 10   continue
C
      icount=0
 15   continue
      ss1=1d10
      do 100 j=1,n-1
         do 20 i=1,n
            x(i,2)=dsin(pi*dble(j)*dble(i)/dble(n))
            x(i,3)=dcos(pi*dble(j)*dble(i)/dble(n))
 20      continue
         if(j*(j/2).ne.j) then
            th=pi*dble(j)/dble(n)
            beta1=dsin(th)/(1d0-dcos(th))
            beta1=2d0*beta1/dble(n)
            beta2=-2d0/dble(n)
            do 5 i=1,n
               x(i,1)=1d0-beta1*x(i,2)-beta2*x(i,3)
 5          continue
         else
            do 6 i=1,n
               x(i,1)=1d0
 6          continue
         endif
c         write(*,*) sb1,sb2,dsin(th)/(1d0-dcos(th)),'here'
         sx1=0d0
         sx2=0d0
         do 21 i=1,n
            sx1=sx1+x(i,1)*x(i,2)
            sx2=sx2+x(i,1)*x(i,3)
 21      continue
c         write(*,*) sx1,sx2
         call robst(res,x,n,theta,res1,cnt,fcnt,scl)
c         write(*,*) scl
c         return
         ss=0d0
         do 25 i=1,n
            ss=ss+rhoh(res1(i)/scl,cnt)
 25      continue
         if(ss.lt.ss1) then
            ss1=ss
            jb=j
            do 30 i=1,n
               ress(i)=res1(i)
 30         continue
         endif
 100  continue
      pval=sd20*(ss0-ss1)/sd10
      pval=1d0-prgamma(pval,0.5d0)**(n-1)
       if(pval.lt.alpha) then
         icount=icount+1
         pp(icount,2)=pval
        if(verb) write(*,'(2(1x,I5),1x,e9.3,1x,f7.2)') icount,jb,pval
     $           ,scl
         pp(icount,1)=dble(jb)
         do 40 i=1,n
            x(i,1)=dsin(pi*dble(jb)*dble(i)/dble(n))
            x(i,2)=dcos(pi*dble(jb)*dble(i)/dble(n))
 40      continue
         scl=-1d0
         call robst(ress,x,n,theta,res,cnt,fcnt,scl) 
         if(icount.eq.kmax) return
         ss0=0d0
         sd10=0d0
         sd20=0d0
         do 50 i=1,n
            ss0=ss0+rhoh(res(i)/scl,cnt)
            sd10=sd10+psih(res(i)/scl,cnt)**2
            sd20=sd20+psih1(res(i)/scl,cnt)
 50   continue
         goto 15
      else
         kmax=icount
         write(*,*) pval,sd20*(ss0-ss1)/sd10
         return
      endif
      end
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
      subroutine robst(y,x,n,theta,res,cnt,fcnt,scl)
      integer n
      double precision y(n),x(n,3),theta(3),res(n)
      double precision cnt,scl,fcnt
C
      double precision ss,ss1,xl,xs,xc,ssx1
      double precision psih
C
C     INTIAL VALUE OF theta LEAST SQUARES
C
      xl=0d0
      xs=0d0
      xc=0d0
      ssx1=0d0
      do 10 i=1,n
         ssx1=ssx1+x(i,1)**2
         xl=xl+y(i)*x(i,1)
         xs=xs+y(i)*x(i,2)
         xc=xc+y(i)*x(i,3)
 10   continue
      theta(1)=xl/ssx1
      theta(2)=2d0*xs/dble(n)
      theta(3)=2d0*xc/dble(n)
      ss=0d0
      do 20 i=1,n
         res(i)=y(i)-theta(1)*x(i,1)-theta(2)*x(i,2)-theta(3)*x(i,3)
         ss=ss+res(i)**2
 20   continue
      ss=dsqrt(ss/dble(n))/fcnt
C
C     Start of iteration
C
 25   continue
C
      do 30 i=1,n
         if(scl.le.0d0) then
            res(i)=ss*psih(res(i)/ss,cnt)
         else
            res(i)=scl*psih(res(i)/scl,cnt)
         endif
 30   continue
      xl=0d0
      xs=0d0
      xc=0d0
      do 40 i=1,n
         xl=xl+res(i)*x(i,1)
         xs=xs+res(i)*x(i,2)
         xc=xc+res(i)*x(i,3)
 40   continue
      xl=xl/ssx1
      xs=2d0*xs/dble(n)
      xc=2d0*xc/dble(n)
      theta(1)=theta(1)+xl
      theta(2)=theta(2)+xs
      theta(3)=theta(3)+xc
      ss1=0d0
      do 50 i=1,n
         res(i)=y(i)-theta(1)*x(i,1)-theta(2)*x(i,2)-theta(3)*x(i,3)
         if(scl.le.0d0) then
            ss1=ss1+psih(res(i)/ss,cnt)**2
         else
            ss1=ss1+psih(res(i)/scl,cnt)**2
         endif
 50   continue
      if(scl.le.0d0) then
         ss1=ss*dsqrt(ss1/dble(n))/fcnt
      else
         ss1=scl*dsqrt(ss1/dble(n))/fcnt
      endif
      if(dabs(ss1-ss).gt.1d-3*ss1) then
         ss=ss1
         goto 25
      endif
C
      if(scl.le.0d0) scl=ss1
      return
      end
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
      double precision function betai(x,a,b)
      double precision x,a,b
C
      double precision betacf,gammln
      double precision bt
C
C
C
      if(x.eq.0d0.or.x.eq.1d0) then
         bt=0d0
      else
         bt=dexp(gammln(a+b)-gammln(a)-gammln(b)+a*dlog(x)+b*dlog(1d0-x)
     $        )
      endif
      if(x.le.(a+1d0)/(a+b+2d0)) then
         betai=bt*betacf(a,b,x)/a
         return
      else
         betai=1d0-bt*betacf(b,a,1d0-x)/b
         return
      endif
C     
      end
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
      double precision function betacf(a,b,x)
      double precision a,b,x
C
      double precision eps,fpmin
      integer maxit
      parameter(maxit=100,eps=4d-7,fpmin=1d-30)
C
      double precision aa,c,d,del,h,qab,qam,qap
      integer m2,m
C
      qab=a+b
      qap=a+1d0
      qam=a-1d0
      c=1d0
      d=1d0-qab*x/qap
      if(dabs(d).lt.fpmin) d=fpmin
      d=1d0/d
      h=d
      do 11 m=1,maxit
         m2=2*m
         aa=dble(m)*(b-dble(m))*x/((qam+dble(m2))*(a+dble(m2)))
         d=1d0+aa*d
         if(dabs(d).lt.fpmin) d=fpmin
         c=1d0+aa/c
         if(dabs(c).lt.fpmin) c=fpmin
         d=1d0/d
         h=h*d*c
         aa=-(a+dble(m))*(qab+dble(m))*x/((a+dble(m2))*(qap+dble(m2)))
         d=1d0+aa*d
         if(dabs(d).lt.fpmin)d=fpmin
         c=1d0+aa/c
         if(dabs(c).lt.fpmin) c=fpmin
         d=1d0/d
         del=d*c
         h=h*del
         if(dabs(del-1d0).lt.eps) goto 1
 11   continue
C
 1    betacf=h
      return
      end
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
      double precision function gammln(xx)
      double precision xx
      integer j
      double precision ser,stp,tmp,x,y
      double precision cof(6)
      save cof,stp
      data cof,stp/76.18009172947146d0,-86.50532032941677d0,24
     $     .01409824083091d0,-1.231739572450155d0,0.1208650973866179d-2,
     $     -0.53952393849553d-5,2.5066282746310005d0/
      x=xx
      y=x
      tmp=x+5.5d0
      tmp=(x+0.5)*dlog(tmp)-tmp
      ser=1.000000000190015d0
      do 11 j=1,6
         y=y+1d0
         ser=ser+cof(j)/y
 11   continue
      gammln=tmp+dlog(stp*ser/x)
      return
      end
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
      double precision function rhoh(x,cn)
      double precision x,cn
C
C
c      if(dabs(cn*x).ge.15d1) then
c         rhoh=dabs(x)
c      else
c        rhoh=2d0*dlog(0.5d0+0.5d0*dexp(cn*x))/cn-x
c      endif
      if(dabs(x).le.cn) then
         rhoh=0.5d0*x**2
      else
         rhoh=cn*dabs(x)-0.5d0*cn**2
      endif
      return
      end
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
      double precision function psih(x,cn)
      double precision x,cn
C
      double precision dsign
c      double precision u
C
c      if(dabs(cn*x).le.1.5d1) then
c         u=dexp(cn*x)
c         psih=(u-1d0)/(u+1d0)
c      else
c        psih=dsign(1d0,x)
c      endif
      if(dabs(x).le.cn) then
         psih=x
      else
         psih=cn*dsign(1d0,x)
      endif
      return
      end
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
      double precision function psih1(x,cn)
      double precision x,cn
C
c      double precision u
C
c      if(dabs(cn*x).ge.1.5d1) then
c         psih1=0d0
c      else
c         u=dexp(cn*x)
c         psih1=2d0*cn*u/(1d0+u)**2
c      endif
      if(dabs(x).le.cn) then
         psih1=1d0
      else
         psih1=0d0
      endif
      return
      end
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC%
C
C
      DOUBLE PRECISION FUNCTION PRGAMMA(X,AK)
      DOUBLE PRECISION X,AK
C
      DOUBLE PRECISION A,AAK,Y
      DOUBLE PRECISION KH0,PRGAU
C
      IF(AK.GE.3D1.OR.DABS(X-AK).GE.2D0*DSQRT(AK)) THEN
         Y=X/AK
         PRGAMMA=PRGAU(DSQRT(2D0)*KH0(Y,AK))
      ELSE
         J=1
 10      CONTINUE
         IF(AK+DBLE(J).LT.3D1) THEN
            J=J+1
            GOTO 10
         ENDIF
         AAK=AK+DBLE(J)
c         write(*,*) J
         SUM=1D0
         A=1D0
         DO 20 I=1,J-1
            A=A*X/(AK+DBLE(I))
            SUM=SUM+A
 20      CONTINUE
         SUM=SUM*DEXP(AK*DLOG(X)-X)/DGAMMA(AK+1D0)
         Y=X/AAK
         PRGAMMA=SUM+PRGAU(DSQRT(2D0)*KH0(Y,AAK))
      ENDIF
C      
      END
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
      DOUBLE PRECISION FUNCTION KH0(X,AK)
      DOUBLE PRECISION X,AK
C
      DOUBLE PRECISION XMN,Y
C
C
      IF(DABS(X-1D0).GT.1D-3) THEN
         KH0=(X-1D0)**2/(X-1D0-DLOG(X))
         KH0=0.5D0*DLOG(KH0/2D0)
      ELSE
         KH0=0D0
      ENDIF
C
      KH0=KH0+AK*(X-1D0-DLOG(X))
      CALL KH0MIN(AK,XMN,Y)
      KH0=DSQRT(DMAX1(0D0,KH0-Y))
      IF(X.LT.XMN) KH0=-KH0
C      
      END
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
      DOUBLE PRECISION FUNCTION KH01(X,AK)
      DOUBLE PRECISION X,AK
C
C
C
      IF(DABS(X-1D0).GT.1D-3) THEN
         KH01=2D0*X*(X-1D0-DLOG(X))-(X-1D0)**2
         KH01=KH01/(2D0*(X-1D0)*(X-1D0-DLOG(X)))
      ELSE
         KH01=(1D0-2D0*(X-1D0))/(3D0*X*(1D0-2D0*(X-1D0)/3D0))
      ENDIF
C
      KH01=KH01+AK*(X-1D0)/X
C
      END
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
      SUBROUTINE KH0MIN(AK,XMIN,Y)
      DOUBLE PRECISION AK,XMIN,Y
C
      DOUBLE PRECISION X0,X1,X2
      DOUBLE PRECISION KH01

C
      X1=1D0
      X0=1D0
 10   CONTINUE
      X0=X0/2D0
      Y=KH01(X0,AK)
      IF(Y.GT.0D0) GOTO 10
C
 20   CONTINUE
      X2=(X0+X1)/2D0
      IF(X1-X0.LT.1D-8) THEN
         XMIN=(X0+X1)/2D0
         GOTO 30
      ENDIF
      Y=KH01(X2,AK)
      IF(Y.GT.0D0) THEN
         X1=X2
      ELSE
         X0=X2
      ENDIF
      GOTO 20
C
 30   CONTINUE
C
      IF(DABS(XMIN-1D0).GT.1D-8) THEN
         Y=(XMIN-1D0)**2/(XMIN-1D0-DLOG(XMIN))
         Y=0.5D0*DLOG(Y/2D0)
      ELSE
         KH0=0D0
      ENDIF
C
      Y=Y+AK*(XMIN-1D0-DLOG(XMIN))
C
      END
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
      DOUBLE PRECISION	FUNCTION PRGAU(X)
      DOUBLE PRECISION X
      DOUBLE PRECISION B(5),RT2PI,P,S,T,Y

      DATA B/.31938153D0,-.356563782D0,1.781477937D0,-1.821255978D0,1
     $     .330274429D0/,RT2PI/2.506628275D0/,P/.2316419D0/

      Y=DABS(X)
      IF(Y.GT.10D0) THEN
         PRGAU=1D0
      ELSE
         T=(1D0+P*Y)**(-1)
         S=B(1)*T+B(2)*T**2+B(3)*T**3+B(4)*T**4+B(5)*T**5
         PRGAU=1D0-DEXP(-0.5D0*Y**2)*S/RT2PI
      ENDIF
      IF(X.GE.0D0) RETURN
      PRGAU=1D0-PRGAU
      END
C
C
